OGRE: Ogre::DeflateStream Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | List of all members
Ogre::DeflateStream Class Reference

Stream which compresses / uncompresses data using the 'deflate' compression algorithm. More...

`#include <OgreDeflate.h>`

Inheritance diagram for Ogre::DeflateStream:
[legend]

## Public Types
enum | AccessMode { READ = 1, WRITE = 2 }
enum | StreamType { Invalid = -1, Deflate = 0, ZLib = 1, GZip = 2 }
| Requested stream type. More...

## Public Member Functions
| DeflateStream (const DataStreamPtr &compressedStream, const String &tmpFileName="", size_t avail_in=0)
| Constructor for creating unnamed stream wrapping another stream. More...
| DeflateStream (const String &name, const DataStreamPtr &compressedStream, const String &tmpFileName="", size_t avail_in=0)
| Constructor for creating named stream wrapping another stream. More...
| DeflateStream (const String &name, const DataStreamPtr &compressedStream, StreamType streamType, const String &tmpFileName="", size_t avail_in=0)
| Constructor for creating named stream wrapping another stream. More...
| ~DeflateStream ()
void | close (void)
| Close the stream; this makes further operations invalid. More...
bool | eof (void) const
| Returns true if the stream has reached the end. More...
uint16 | getAccessMode () const
| Gets the access mode of the stream. More...
virtual String | getAsString (void)
| Returns a String containing the entire stream. More...
virtual String | getLine (bool trimAfter=true)
| Returns a String containing the next line of data, optionally trimmed for whitespace. More...
const String & | getName (void)
| Returns the name of the stream, if it has one. More...
bool | isCompressedStreamValid () const
| Returns whether the compressed stream is valid deflated data. More...
virtual bool | isReadable () const
| Reports whether this stream is readable. More...
virtual bool | isWriteable () const
| Reports whether this stream is writeable. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
template<typename T >
DataStream & | operator>> (T &val)
size_t | read (void *buf, size_t count)
| Read the requisite number of bytes from the stream, stopping at the end of the file. More...
virtual size_t | readLine (char *buf, size_t maxCount, const String &delim="\n")
| Get a single line from the stream. More...
void | seek (size_t pos)
| Repositions the read point to a specified byte. More...
size_t | size (void) const
| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream. More...
void | skip (long count)
| Skip a defined number of bytes. More...
virtual size_t | skipLine (const String &delim="\n")
| Skip a single line from the stream. More...
size_t | tell (void) const
| Returns the current byte offset from beginning. More...
size_t | write (const void *buf, size_t count)
| Write the requisite number of bytes from the stream (only applicable to streams that are not read-only) More...

## Detailed Description

Stream which compresses / uncompresses data using the 'deflate' compression algorithm.

Remarks
  This stream is designed to wrap another stream for the actual source / destination of the compressed data, it has no concrete source / data itself. The idea is that you pass uncompressed data through this stream, and the underlying stream reads/writes compressed data to the final source.

Note
  This is an alternative to using a compressed archive since it is able to compress & decompress regardless of the actual source of the stream. You should avoid using this with already compressed archives. Also note that this cannot be used as a read / write stream, only a read-only or write-only stream.

## Member Enumeration Documentation

## ◆ AccessMode

enum Ogre::DataStream::AccessMode
| inherited

Enumerator
READ |
WRITE |

## ◆ StreamType

enum Ogre::DeflateStream::StreamType

Requested stream type.

All are essentially the same deflate stream with varying wrapping. ZLib is used by default.

Enumerator
Invalid |
Deflate | Unexpected stream type or uncompressed data.
ZLib | no header, no checksum, rfc1951
GZip | 2 byte header, 4 byte footer with adler32 checksum, rfc1950

## Constructor & Destructor Documentation

## ◆ DeflateStream() [1/3]

Ogre::DeflateStream::DeflateStream | ( | const DataStreamPtr & | compressedStream,
|  | const String & | tmpFileName = `""`,
|  | size_t | avail_in = `0`
| ) |  |

Constructor for creating unnamed stream wrapping another stream.

Parameters

  compressedStream | The stream that this stream will use when reading / writing compressed data. The access mode from this stream will be matched.
  tmpFileName | Path/Filename to be used for temporary storage of incoming data
  avail_in | Available data length to be uncompressed. With it we can uncompress DataStream partly.

## ◆ DeflateStream() [2/3]

Ogre::DeflateStream::DeflateStream | ( | const String & | name,
|  | const DataStreamPtr & | compressedStream,
|  | const String & | tmpFileName = `""`,
|  | size_t | avail_in = `0`
| ) |  |

Constructor for creating named stream wrapping another stream.

Parameters

  name | The name to give this stream
  compressedStream | The stream that this stream will use when reading / writing compressed data. The access mode from this stream will be matched.
  tmpFileName | Path/Filename to be used for temporary storage of incoming data
  avail_in | Available data length to be uncompressed. With it we can uncompress DataStream partly.

## ◆ DeflateStream() [3/3]

Ogre::DeflateStream::DeflateStream | ( | const String & | name,
|  | const DataStreamPtr & | compressedStream,
|  | StreamType | streamType,
|  | const String & | tmpFileName = `""`,
|  | size_t | avail_in = `0`
| ) |  |

Constructor for creating named stream wrapping another stream.

Parameters

  name | The name to give this stream
  compressedStream | The stream that this stream will use when reading / writing compressed data. The access mode from this stream will be matched.
  streamType | The type of compressed stream
  tmpFileName | Path/Filename to be used for temporary storage of incoming data
  avail_in | Available data length to be uncompressed. With it we can uncompress DataStream partly.

## ◆ ~DeflateStream()

Ogre::DeflateStream::~DeflateStream | ( |  | ) |

## Member Function Documentation

## ◆ close()

void Ogre::DeflateStream::close | ( | void |  | ) |
| virtual

Close the stream; this makes further operations invalid.

Implements Ogre::DataStream.

## ◆ eof()

bool Ogre::DeflateStream::eof | ( | void |  | ) | const
| virtual

Returns true if the stream has reached the end.

Implements Ogre::DataStream.

## ◆ getAccessMode()

uint16 Ogre::DataStream::getAccessMode | ( |  | ) | const
| inlineinherited

Gets the access mode of the stream.

## ◆ getAsString()

virtual String Ogre::DataStream::getAsString | ( | void |  | ) |
| virtualinherited

Returns a String containing the entire stream.

Remarks
  This is a convenience method for text streams only, allowing you to retrieve a String object containing all the data in the stream.

## ◆ getLine()

virtual String Ogre::DataStream::getLine | ( | bool | trimAfter = `true` | ) |
| virtualinherited

Returns a String containing the next line of data, optionally trimmed for whitespace.

Remarks
  This is a convenience method for text streams only, allowing you to retrieve a String object containing the next line of data. The data is read up to the next newline character and the result trimmed if required.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  trimAfter | If true, the line is trimmed for whitespace (as in String.trim(true,true))

## ◆ getName()

const String& Ogre::DataStream::getName | ( | void |  | ) |
| inlineinherited

Returns the name of the stream, if it has one.

## ◆ isCompressedStreamValid()

bool Ogre::DeflateStream::isCompressedStreamValid | ( |  | ) | const
| inline

Returns whether the compressed stream is valid deflated data.

Remarks
  If you pass this class a READ stream which is not compressed with the deflate algorithm, this method returns false and all read commands will actually be executed as passthroughs as a fallback.

## ◆ isReadable()

virtual bool Ogre::DataStream::isReadable | ( |  | ) | const
| inlinevirtualinherited

Reports whether this stream is readable.

## ◆ isWriteable()

virtual bool Ogre::DataStream::isWriteable | ( |  | ) | const
| inlinevirtualinherited

Reports whether this stream is writeable.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ operator>>()

template<typename T >

DataStream& Ogre::DataStream::operator>> | ( | T & | val | ) |
| inherited

## ◆ read()

size_t Ogre::DeflateStream::read | ( | void * | buf,
|  | size_t | count
| ) |  |
| virtual

Read the requisite number of bytes from the stream, stopping at the end of the file.

Parameters

  buf | Reference to a buffer pointer
  count | Number of bytes to read

Returns
  The number of bytes read

Implements Ogre::DataStream.

## ◆ readLine()

virtual size_t Ogre::DataStream::readLine | ( | char * | buf,
|  | size_t | maxCount,
|  | const String & | delim = `"\n"`
| ) |  |
| virtualinherited

Get a single line from the stream.

Remarks
  The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  buf | Reference to a buffer pointer
  maxCount | The maximum length of data to be read, excluding the terminating character
  delim | The delimiter to stop at

Returns
  The number of bytes read, excluding the terminating character

Reimplemented in Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

## ◆ seek()

void Ogre::DeflateStream::seek | ( | size_t | pos | ) |
| virtual

Repositions the read point to a specified byte.

Implements Ogre::DataStream.

## ◆ size()

size_t Ogre::DataStream::size | ( | void |  | ) | const
| inlineinherited

Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.

## ◆ skip()

void Ogre::DeflateStream::skip | ( | long | count | ) |
| virtual

Skip a defined number of bytes.

This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.

Implements Ogre::DataStream.

## ◆ skipLine()

virtual size_t Ogre::DataStream::skipLine | ( | const String & | delim = `"\n"` | ) |
| virtualinherited

Skip a single line from the stream.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  delim | The delimiter(s) to stop at

Returns
  The number of bytes skipped

Reimplemented in Ogre::MemoryDataStream.

## ◆ tell()

size_t Ogre::DeflateStream::tell | ( | void |  | ) | const
| virtual

Returns the current byte offset from beginning.

Implements Ogre::DataStream.

## ◆ write()

size_t Ogre::DeflateStream::write | ( | const void * | buf,
|  | size_t | count
| ) |  |
| virtual

Write the requisite number of bytes from the stream (only applicable to streams that are not read-only)

Parameters

  buf | Pointer to a buffer containing the bytes to write
  count | Number of bytes to write

Returns
  The number of bytes written

Reimplemented from Ogre::DataStream.

The documentation for this class was generated from the following file:

- OgreDeflate.h